package dev.shadowsoffire.apotheosis.ench.enchantments.masterwork;

import java.lang.reflect.Method;
import java.lang.invoke.MethodHandles;
import net.minecraftforge.fml.util.ObfuscationReflectionHelper;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.LivingEntity;
import java.util.Collection;
import java.util.ArrayList;
import net.minecraftforge.event.entity.living.LivingDropsEvent;
import net.minecraft.world.entity.player.Player;
import net.minecraft.ChatFormatting;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.network.chat.Component;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.item.enchantment.EnchantmentCategory;
import java.lang.invoke.MethodHandle;
import net.minecraft.world.item.enchantment.Enchantment;

public class ScavengerEnchant extends Enchantment
{
    private static final MethodHandle dropFromLootTable;
    
    public ScavengerEnchant() {
        super(Enchantment.Rarity.VERY_RARE, EnchantmentCategory.WEAPON, new EquipmentSlot[] { EquipmentSlot.MAINHAND });
    }
    
    public int m_6183_(final int level) {
        return 55 + level * level * 12;
    }
    
    public int m_6175_(final int level) {
        return 200;
    }
    
    public int m_6586_() {
        return 3;
    }
    
    public Component m_44700_(final int level) {
        return (Component)((MutableComponent)super.m_44700_(level)).m_130940_(ChatFormatting.DARK_GREEN);
    }
    
    public void drops(final Player p, final LivingDropsEvent e) throws Throwable {
        if (p.m_9236_().f_46443_) {
            return;
        }
        final int scavenger = p.m_21205_().getEnchantmentLevel((Enchantment)this);
        if (scavenger > 0 && p.m_9236_().f_46441_.m_188503_(100) < scavenger * 2.5f) {
            e.getEntity().captureDrops((Collection)new ArrayList());
            ScavengerEnchant.dropFromLootTable.invoke(e.getEntity(), e.getSource(), true);
            e.getDrops().addAll(e.getEntity().captureDrops((Collection)null));
        }
    }
    
    static {
        final Method m = ObfuscationReflectionHelper.findMethod((Class)LivingEntity.class, "m_7625_", new Class[] { DamageSource.class, Boolean.TYPE });
        try {
            m.setAccessible(true);
            dropFromLootTable = MethodHandles.lookup().unreflect(m);
        }
        catch (final IllegalAccessException e) {
            throw new RuntimeException("LivingEntity#dropFromLootTable not located!");
        }
    }
}
